// Filename: messages.h
// Name of author: Petr Kovar
// Work begun:    10/08/2003
// Last modified: 02/12/2006
//
// Description:
// headers for common message output functions

// ------------------------------------------------------------------------------------------------------------------------

// Error codes
#define NO_ULOHY_IN_FILE_ULOHY           100
#define NO_RESENI_IN_FILE_RESITELE       101
#define NO_ULOHY_IN_LIST                 102
#define NO_RESITELE_IN_LIST              103

#define NOT_COMPLETE_DATA                110
#define NO_NUMBER_GIVEN                  111
#define NO_ULOHA_NAME_GIVEN              112
#define NO_POINTS_GIVEN                  113
#define ULOHA_INDEX_NOT_NUMBER           114
#define NO_DATE_GIVEN                    115
#define NO_RESITEL_NAME_GIVEN            116
#define INCOMPLETE_ID                    117
#define NO_ARCHIVE_NAME                  118
#define NO_ULOHA_INDEX                   119

#define POINTS_ARE_NOT_INTEGER           120
#define WRONG_DATE_FORMAT                121

#define ULOHA_TWICE                      130
#define VYRESENA_ULOHA_TWICE             131
#define MORE_POINTS_THAN_TOTAL           132
#define POINTS_NOT_GIVEN                 133
#define ULOHA_NOT_IN_ARCHIVE             134
#define ARCHIV_TWICE                     135

#define CANT_OPEN_FILE_ULOHY             140
#define NOT_CLOSED_FILE_ULOHY            141
#define CANT_OPEN_FILE_RESITELE          142
#define NOT_CLOSED_FILE_RESITELE         143

#define CANT_OPEN_ARCHIV_FILE            150
#define NOT_CLOSED_ARCHIV_FILE           151
#define CANT_OPEN_RESITELE_FILE          152
#define NOT_CLOSED_RESITELE_FILE         153
#define CANT_OPEN_STATISTIKA_FILE        154
#define NOT_CLOSED_STATISTIKA_FILE       155

#define LINE_ULOHY_TOO_LONG              162
#define LINE_RESENI_TOO_LONG             163
#define ERROR_IN_RESITEL_STRUCTURE       164
#define RESITEL_TWICE                    165
#define RESENI_NOT_CHRONOLOGIC           166

#define CANT_OPEN_ARCHIV_HEADINGS        170
#define NOT_CLOSED_ARCHIV_HEADINGS       171
#define CANT_OPEN_ARCHIV_TAILS           172
#define NOT_CLOSED_ARCHIV_TAILS          173

#define CANT_OPEN_RESITELE_HEADINGS      180
#define NOT_CLOSED_RESITELE_HEADINGS     181
#define CANT_OPEN_RESITELE_MIDS          182
#define NOT_CLOSED_RESITELE_MIDS         183
#define CANT_OPEN_RESITELE_TAILS         184
#define NOT_CLOSED_RESITELE_TAILS        185

#define CANT_OPEN_STATISTIKA_HEADINGS    190
#define NOT_CLOSED_STATISTIKA_HEADINGS   191
#define CANT_OPEN_STATISTIKA_TAILS       192
#define NOT_CLOSED_STATISTIKA_TAILS      193

#define BAD_PARAMETERS                   300
#define DATUM_NOT_ALLOCATED              301
#define NO_OUTPUT_FILE                   302
#define NO_INPUT_FILE                    303

// Old Error messages
/*
#define NO_RESENA_ULOHA_FOR_RESITEL      102

*/

/*D
// Various languages localization
#define PACKAGE   "labelings"
#define LOCALEDIR "locale"

// Various languages localization
void language_localization(void);
*/

// print an error message
void error_message(int error_message, char *text);

// print a warning message
void warning_message(int warning_message, char * text);

// ------------------------------------------------------------------------------------------------------------------------

// end of file
