// Filename: statistika.c
// Name of author: Petr Kovar
// Work begun:    16/12/2006
// Last modified: 08/12/2007
//
// Description:
// file with program for generating statistics tables for homel.vsb.cz/~kov16/ulohy

/*
Copyright (C) 2006 Petr Kov
You can reach me at Petr.Kovar@vsb.cz

-------------------------------------

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// ------------------------------------------------------------------------------------------------------------------------

// Standardn knihovny
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
//D#include <time.h>
#include <stdint.h>

// Definice typ
#include "resitele_types.h"
#include "commandline.h"
#include "resitele.h"
#include "statistika.h"
#include "messages.h"

// Dodlat: 
// - statistiku

// Nov typy tabulek ??
/*?
ulohy seazen podle archiv
- een celkem
- een po letech

eitel podle abecedy
- poet loh celkem
- poet plnch loh celkem
- poet bod celkem
- poet loh celkem po letech
- poet plnch loh celkem po letech
- poet bod celkem po letech

Poad loh podle potu een celkem
Poad loh podle potu een po letech

Poad eitel podle potu een celkem
Poad eitel podle potu een po letech

*/

// Alokuj nov seznam s pointery na lohy (pro statistiku)
SADA_ULOH * new_sada_uloh(void) {
  SADA_ULOH * p_sada_uloh;            // nov struktura SADA_ULOH

  // alokuj pam
  p_sada_uloh = (SADA_ULOH *) malloc(sizeof(SADA_ULOH));
  // inicializan hodnoty
  p_sada_uloh->p_first_uloha_element = NULL; // jet dn loha
  p_sada_uloh->n_uloh = 0;                  // ... dn lohy
  // pointer na novou alokovanou strukturu
  return p_sada_uloh;
}

// Uvoln alokovanou pam seznamu pointer
STATUS free_sada_uloh(SADA_ULOH * p_sada_uloh) {
  ULOHA_ELEMENT * p_uloha_element;                       // pointer na poloku seznamu
  ULOHA_ELEMENT * p_next_uloha_element;                  // pointer na dal poloku seznamu

  // projdi celou sadu
  p_uloha_element = p_sada_uloh->p_first_uloha_element;
  while (p_uloha_element != NULL) {
    p_next_uloha_element = p_uloha_element->p_next_uloha_element;
    // uvoln strukturu dal poloky
    free(p_uloha_element);
    // move on
    p_uloha_element = p_next_uloha_element;
  }
  // uvoln strukturu
  free(p_sada_uloh);
  return OK;
}

// Vymae seznam pointer a uvoln alokovanou pam
STATUS erase_sada_uloh(SADA_ULOH * p_sada_uloh) {
  ULOHA_ELEMENT * p_uloha_element;                       // pointer na poloku seznamu
  ULOHA_ELEMENT * p_next_uloha_element;                  // pointer na dal poloku seznamu

  // je neprzdn?
  if (p_sada_uloh != NULL) {
    // projdi celou sadu
    p_uloha_element = p_sada_uloh->p_first_uloha_element;
    while (p_uloha_element != NULL) {
      p_next_uloha_element = p_uloha_element->p_next_uloha_element;
      // uvoln strukturu dal poloky
      free(p_uloha_element);
      // move on
      p_uloha_element = p_next_uloha_element;
    }
    // sada je przdn
    p_sada_uloh->p_first_uloha_element = NULL;
    p_sada_uloh->n_uloh = 0;
  }
  return OK;
}

// Alokuj novou poloku seznamu s pointery na lohy (pro statistiku)
ULOHA_ELEMENT * new_uloha_element(ULOHA * p_uloha) {
  ULOHA_ELEMENT * p_uloha_element;               // nov struktura ULOHA_ELEMENT

  // alokuj pam
  p_uloha_element = (ULOHA_ELEMENT *) malloc(sizeof(ULOHA_ELEMENT));
  // inicializan hodnoty
  p_uloha_element->p_uloha = p_uloha;           // pointer na novou lohu
  p_uloha_element->p_next_uloha_element = NULL;  // dn dal poloka nen
  // pointer na novou alokovanou strukturu
  return p_uloha_element;
}

// free_uloha_element
/* neteba */

// Pidej element do sady loh
STATUS add_uloha_element(SADA_ULOH * p_sada_uloh, ULOHA_ELEMENT * p_uloha_element) {
  ULOHA_ELEMENT * p_last_uloha_element;               // pointer pro prochzen sady loh

  // zaa lohu do struktury
  if (p_sada_uloh->p_first_uloha_element == NULL) {  // je to prvn loha?
    p_sada_uloh->p_first_uloha_element = p_uloha_element;
  }
  else {  // zaa na konec seznamu
    p_last_uloha_element = p_sada_uloh->p_first_uloha_element;
    while (p_last_uloha_element->p_next_uloha_element != NULL) {
      p_last_uloha_element = p_last_uloha_element->p_next_uloha_element;
    }
    p_last_uloha_element->p_next_uloha_element = p_uloha_element;
  }
  // dal loha
  p_sada_uloh->n_uloh++;
  // done
  return OK;
}

// Pidej lohu do sady loh
STATUS add_sada_uloha(SADA_ULOH * p_sada_uloh, ULOHA * p_uloha) {
  add_uloha_element(p_sada_uloh, new_uloha_element(p_uloha));
  // done
  return OK;
}

// Vype sadu loh do souboru
STATUS print_sada_uloh(FILE * out_file, SADA_ULOH * p_sada_uloh) {
  ULOHA_ELEMENT * p_uloha_element;                    // pointer pro prochzen seznamu

  // zani od prvn poloky
  p_uloha_element = p_sada_uloh->p_first_uloha_element;
  // projdi cel seznam
  while (p_uloha_element != NULL) {
    //?    else if (parameters->info_ulohy == 2) {  // vypi slo a jmno lohy
    fprintf(out_file, "%s.%d. %s", p_uloha_element->p_uloha->p_archiv->jmeno_archivu, p_uloha_element->p_uloha->index_ulohy, p_uloha_element->p_uloha->jmeno_ulohy);
      //?    }
    // oddl poloky rkou
    if (p_uloha_element->p_next_uloha_element != NULL) {
      fprintf(out_file, ", ");
    }
    // move on
    p_uloha_element = p_uloha_element->p_next_uloha_element;
  }
  // done
  return OK;
}

// Alokuj nov seznam s pointery na eitele (pro statistiku)
SADA_RESITELU * new_sada_resitelu(void) {
  SADA_RESITELU * p_sada_resitelu;            // nov struktura SADA_RESITELU

  // alokuj pam
  p_sada_resitelu = (SADA_RESITELU *) malloc(sizeof(SADA_RESITELU));
  // inicializan hodnoty
  p_sada_resitelu->p_first_resitel_element = NULL;  // jet dn eitel
  p_sada_resitelu->n_resitelu = 0;                  // ... dn eitel
  // pointer na novou alokovanou strukturu
  return p_sada_resitelu;
}

// Uvoln alokovanou pam seznamu pointer
STATUS free_sada_resitelu(SADA_RESITELU * p_sada_resitelu) {
  RESITEL_ELEMENT * p_resitel_element;                       // pointer na poloku seznamu
  RESITEL_ELEMENT * p_next_resitel_element;                  // pointer na dal poloku seznamu

  // projdi celou sadu
  p_resitel_element = p_sada_resitelu->p_first_resitel_element;
  while (p_resitel_element != NULL) {
    p_next_resitel_element = p_resitel_element->p_next_resitel_element;
    // uvoln strukturu dal poloky
    free(p_resitel_element);
    // move on
    p_resitel_element = p_next_resitel_element;
  }
  // uvoln strukturu
  free(p_sada_resitelu);
  return OK;
}

// Vymae seznam pointer a uvoln alokovanou pam
STATUS erase_sada_resitelu(SADA_RESITELU * p_sada_resitelu) {
  RESITEL_ELEMENT * p_resitel_element;                       // pointer na poloku seznamu
  RESITEL_ELEMENT * p_next_resitel_element;                  // pointer na dal poloku seznamu

  // je neprzdn?
  if (p_sada_resitelu != NULL) {
    // projdi celou sadu
    p_resitel_element = p_sada_resitelu->p_first_resitel_element;
    while (p_resitel_element != NULL) {
      p_next_resitel_element = p_resitel_element->p_next_resitel_element;
      // uvoln strukturu dal poloky
      free(p_resitel_element);
      // move on
      p_resitel_element = p_next_resitel_element;
    }
    // sada je przdn
    p_sada_resitelu->p_first_resitel_element = NULL;
    p_sada_resitelu->n_resitelu = 0;
  }
  return OK;
}

// Alokuj novou poloku seznamu s pointery na eitele (pro statistiku)
RESITEL_ELEMENT * new_resitel_element(RESITEL * p_resitel) {
  RESITEL_ELEMENT * p_resitel_element;               // nov struktura RESITEL_ELEMENT

  // alokuj pam
  p_resitel_element = (RESITEL_ELEMENT *) malloc(sizeof(RESITEL_ELEMENT));
  // inicializan hodnoty
  p_resitel_element->p_resitel = p_resitel;              // pointer na novho eitele
  p_resitel_element->p_next_resitel_element = NULL;  // dn dal poloka nen
  // pointer na novou alokovanou strukturu
  return p_resitel_element;
}

// free_resitel_element
/* neteba */

// Pidej element do sady eitel
STATUS add_resitel_element(SADA_RESITELU * p_sada_resitelu, RESITEL_ELEMENT * p_resitel_element) {
  RESITEL_ELEMENT * p_last_resitel_element;               // pointer pro prochzen sady eitel

  // zaa eitele do struktury
  if (p_sada_resitelu->p_first_resitel_element == NULL) {  // je to prvn eitel?
    p_sada_resitelu->p_first_resitel_element = p_resitel_element;
  }
  else {  // zaa na konec seznamu
    p_last_resitel_element = p_sada_resitelu->p_first_resitel_element;
    while (p_last_resitel_element->p_next_resitel_element != NULL) {
      p_last_resitel_element = p_last_resitel_element->p_next_resitel_element;
    }
    p_last_resitel_element->p_next_resitel_element = p_resitel_element;
  }
  // dal eitel
  p_sada_resitelu->n_resitelu++;
  // done
  return OK;
}

// Pidej eitele do sady eitel
STATUS add_sada_resitel(SADA_RESITELU * p_sada_resitelu, RESITEL * p_resitel) {
  add_resitel_element(p_sada_resitelu, new_resitel_element(p_resitel));
  // done
  return OK;
}

// Vype sadu eitel do souboru
STATUS print_sada_resitelu(FILE * out_file, SADA_RESITELU * p_sada_resitelu) {
  RESITEL_ELEMENT * p_resitel_element;                    // pointer pro prochzen seznamu

  // zani od prvn poloky
  p_resitel_element = p_sada_resitelu->p_first_resitel_element;
  // projdi cel seznam
  while (p_resitel_element != NULL) {
    //?    else if (parameters->info_ulohy == 2) {  // vypi jmno eitele
    fprintf(out_file, "%s", p_resitel_element->p_resitel->jmeno_resitele);
      //?    }
    // oddl poloky rkou
    if (p_resitel_element->p_next_resitel_element != NULL) {
      fprintf(out_file, ", ");
    }
    // move on
    p_resitel_element = p_resitel_element->p_next_resitel_element;
  }
  // done
  return OK;
}

// poty een vech loh
STATUS pocty_reseni_uloh(SEZNAM_ULOH * p_seznam_uloh, FILE * soubor_statistika) {
  ARCHIV * p_archiv;                         // pointer pro prochzen archiv
  ULOHA * p_uloha;                           // pointer pro prochzen loh
  int n_uloh = 0;                            // ta loh

  // hlavika tabulky eitel
  fprintf(soubor_statistika, "<h3>Tabulka potu een loh</h3>\n\n");
  fprintf(soubor_statistika, "<table border=\"1\" align=\"center\" class=\"tab\">\n");
  fprintf(soubor_statistika, "<tr class=\"tabhead\">\n");
  fprintf(soubor_statistika, " <th>slo a jmno lohy</th>\n");
  fprintf(soubor_statistika, " <th>Poet vech een</th>\n");
  fprintf(soubor_statistika, " <th>Poet plnch een</th>\n");
  fprintf(soubor_statistika, "</tr>\n");

  // zani od prvnho archivu
  p_archiv = p_seznam_uloh->p_first_archiv;
  // projdi cel seznam
  while (p_archiv != NULL) {
    // zani od prvn lohy v archivu
    p_uloha = p_archiv->p_first_uloha;
    // po kadou lohu v archivu
    while (p_uloha != NULL) {
      if (p_uloha->p_archiv->typ_jmena_archivu == TYP_CISLA_STR) {
        fprintf(soubor_statistika, "<tr class=\"tabrow%d\">\n  <td><a href=\"ulohy.php#%s.%d.\">%s.%d. %s</a> (%db)</td><td align=\"center\">%ld</td><td align=\"center\">%ld</td>\n</tr>\n", (n_uloh % 2), p_uloha->p_archiv->jmeno_archivu, p_uloha->index_ulohy, p_uloha->p_archiv->jmeno_archivu, p_uloha->index_ulohy, p_uloha->jmeno_ulohy, p_uloha->body_ulohy, p_uloha->n_reseni, p_uloha->n_uplnych_reseni);
      }
      else {
        fprintf(soubor_statistika, "<tr class=\"tabrow%d\">\n  <td><a href=\"archiv%02d.php#%s.%d.\">%s.%d. %s</a> (%db)</td><td align=\"center\">%ld</td><td align=\"center\">%ld</td>\n</tr>\n", (n_uloh % 2), p_uloha->p_archiv->cislo_archivu, p_uloha->p_archiv->jmeno_archivu, p_uloha->index_ulohy, p_uloha->p_archiv->jmeno_archivu, p_uloha->index_ulohy, p_uloha->jmeno_ulohy, p_uloha->body_ulohy, p_uloha->n_reseni, p_uloha->n_uplnych_reseni);
      }
      // move on
      p_uloha = p_uloha->p_next_uloha;
      n_uloh++;
    }
    // pejdi na dal archiv
    p_archiv = p_archiv->p_next_archiv;
  }
  // konec tabulky
  fprintf(soubor_statistika, "<tr class=\"tabhead\"><td colspan=\"4\" align=\"center\">Tabulka obsahuje celkem %d loh v %d archivech vetn hlavn strnky.</td>\n</tr>\n", p_seznam_uloh->n_uloh, p_seznam_uloh->n_archivu);
  fprintf(soubor_statistika, "</table>\n");
  // done
  return OK;
}

// Nkolik nej
STATUS nekolik_nej(SEZNAM_RESITELU * p_seznam_resitelu, SEZNAM_ULOH * p_seznam_uloh, FILE * soubor_statistika) {
  ARCHIV * p_archiv;                         // pointer pro prochzen archiv
  ULOHA * p_uloha;                           // pointer pro prochzen loh
  RESITEL * p_resitel;                       // pointer pro prochzen seznamu eitel
  RESENI_ULOHY * p_reseni_ulohy;             // pointer pro prochzen een jedn lohy

  BODY body_max;                             // nejvce bod za lohu
  SADA_ULOH * p_ulohy_body_max;              // pointer na lohy za nejvce bod
  BODY body_min;                             // nejmn bod za lohu
  SADA_ULOH * p_ulohy_body_min;              // pointer na lohy za nejmn bod
  SADA_ULOH * p_ulohy_body_sum_max;          // pointer na lohy za kterou nasbrno nejvce bod
  SADA_ULOH * p_ulohy_body_sum_min;          // pointer na lohy za kterou nasbrno nejmn bod
  POCET_RESENI reseni_max;                   // nejastji een lohy
  SADA_ULOH * p_ulohy_reseni_max;            // pointer na nejastji een lohy
  POCET_RESENI reseni_min;                   // nejmn asto een lohy
  SADA_ULOH * p_ulohy_reseni_min;            // pointer na nejmn asto een lohy
  POCET_RESENI uplne_reseni_max;             // nejastji een lohy
  SADA_ULOH * p_ulohy_uplne_reseni_max;      // pointer na nejastji een lohy
  POCET_RESENI uplne_reseni_min;             // nejmn asto een lohy
  SADA_ULOH * p_ulohy_uplne_reseni_min;      // pointer na nejmn asto een lohy
  POCET_RESENI max_rozdil_reseni;            // lohy s nejvtm rozdlem sprvnch a stench een
  SADA_ULOH * p_ulohy_max_rozdil_reseni;     // pointer na lohy s nejvtm rozdlem sprvnch a stench een
  BODY resitele_body_max;                    // nejvt poet bod
  SADA_RESITELU * p_resitele_body_max;       // pointer na eitele s nejvtm potem bod
  BODY resitele_body_min;                    // nejmen poet bod
  SADA_RESITELU * p_resitele_body_min;       // pointer na eitele s nejmenm potem bod

  BODY suma_bodu;                            // souet bod za vechny lohy celkem
  long int suma_bodu_resitelu;               // souet bod od vech eitel
  long int n_reseni_resitelu;                // poet vech een od vech eitel
  long int suma_bodu_reseni;                 // souet nasbranch bod za jednu lohu
  long int suma_bodu_reseni_max;             // nejvt souet nasbranch bod za jednu lohu
  long int suma_bodu_reseni_min;             // nejmen souet nasbranch bod za jednu lohu

  // inicializace
  suma_bodu = 0;
  suma_bodu_resitelu = 0;
  n_reseni_resitelu = 0;
  suma_bodu_reseni_max = 0;
  suma_bodu_reseni_min = INT32_MAX;

  reseni_max = 0;
  reseni_min = INT32_MAX;
  uplne_reseni_max = 0;
  uplne_reseni_min = INT32_MAX;
  max_rozdil_reseni = 0;
  body_max = p_seznam_uloh->p_first_archiv->p_first_uloha->body_ulohy;
  body_min = p_seznam_uloh->p_first_archiv->p_first_uloha->body_ulohy;
  resitele_body_max = 0;
  resitele_body_min = INT32_MAX;
  // nov struktury
  p_ulohy_reseni_max = new_sada_uloh();
  p_ulohy_reseni_min = new_sada_uloh();
  p_ulohy_uplne_reseni_max = new_sada_uloh();
  p_ulohy_uplne_reseni_min = new_sada_uloh();
  p_ulohy_max_rozdil_reseni = new_sada_uloh();
  p_ulohy_body_max = new_sada_uloh();
  p_ulohy_body_min = new_sada_uloh();
  p_ulohy_body_sum_max = new_sada_uloh();
  p_ulohy_body_sum_min = new_sada_uloh();
  p_resitele_body_max = new_sada_resitelu();
  p_resitele_body_min = new_sada_resitelu();

  // zani od prvnho archivu
  p_archiv = p_seznam_uloh->p_first_archiv;
  // Jestlie je archiv loh przdn...
  if ((p_seznam_resitelu == NULL) || (p_seznam_resitelu->p_first_resitel == NULL) || (p_seznam_resitelu->n_resitelu == 0)) {
    error_message(NO_ULOHY_IN_LIST, NULL);
  }
  else {
    // projdi cel seznam
    while (p_archiv != NULL) {
      // zani od prvn lohy v archivu
      p_uloha = p_archiv->p_first_uloha;
      // po kadou lohu v archivu
      while (p_uloha != NULL) {
        // zvy souet bod
        suma_bodu += p_uloha->body_ulohy;
        // loha s nejvce eenmi
        if (p_uloha->n_reseni > reseni_max) {
	  // vyma stvajc seznam
	  erase_sada_uloh(p_ulohy_reseni_max);
	  // do przdnho seznam a pidej tuto lohu
	  add_sada_uloha(p_ulohy_reseni_max, p_uloha);
	  reseni_max = p_uloha->n_reseni;
	}
        else if (p_uloha->n_reseni == reseni_max) {
	  // pidej tuto lohu
	  add_sada_uloha(p_ulohy_reseni_max, p_uloha);
	}
        // loha s nejmn eenmi
        if (p_uloha->n_reseni < reseni_min) {
	  // vyma stvajc seznam
	  erase_sada_uloh(p_ulohy_reseni_min);
	  // do przdnho seznam a pidej tuto lohu
	  add_sada_uloha(p_ulohy_reseni_min, p_uloha);
	  reseni_min = p_uloha->n_reseni;
	}
        else if (p_uloha->n_reseni == reseni_min) {
	  // pidej tuto lohu
	  add_sada_uloha(p_ulohy_reseni_min, p_uloha);
	}
        // loha s nejvce plnmi eenmi
        if (p_uloha->n_uplnych_reseni > uplne_reseni_max) {
	  // vyma stvajc seznam
	  erase_sada_uloh(p_ulohy_uplne_reseni_max);
	  // do przdnho seznam a pidej tuto lohu
	  add_sada_uloha(p_ulohy_uplne_reseni_max, p_uloha);
	  uplne_reseni_max = p_uloha->n_uplnych_reseni;
	}
        else if (p_uloha->n_uplnych_reseni == uplne_reseni_max) {
	  // pidej tuto lohu
	  add_sada_uloha(p_ulohy_uplne_reseni_max, p_uloha);
	}
        // loha s nejmn plnmi eenmi
        if (p_uloha->n_uplnych_reseni < uplne_reseni_min) {
	  // vyma stvajc seznam
	  erase_sada_uloh(p_ulohy_uplne_reseni_min);
	  // do przdnho seznam a pidej tuto lohu
	  add_sada_uloha(p_ulohy_uplne_reseni_min, p_uloha);
	  uplne_reseni_min = p_uloha->n_uplnych_reseni;
	}
        else if (p_uloha->n_uplnych_reseni == uplne_reseni_min) {
	  // pidej tuto lohu
	  add_sada_uloha(p_ulohy_uplne_reseni_min, p_uloha);
	}

        // lohy s nejvtm rozdlem sprvnch a stench een
        if ((p_uloha->n_reseni - p_uloha->n_uplnych_reseni) > max_rozdil_reseni) {
	  // vyma stvajc seznam
	  erase_sada_uloh(p_ulohy_max_rozdil_reseni);
	  // do przdnho seznam a pidej tuto lohu
	  add_sada_uloha(p_ulohy_max_rozdil_reseni, p_uloha);
	  max_rozdil_reseni = (p_uloha->n_reseni - p_uloha->n_uplnych_reseni);
	}
        else if ((p_uloha->n_reseni - p_uloha->n_uplnych_reseni) == max_rozdil_reseni) {
	  // pidej tuto lohu
	  add_sada_uloha(p_ulohy_max_rozdil_reseni, p_uloha);
	}

        // loha za nejvce bod
        if (p_uloha->body_ulohy > body_max) {
	  // vyma stvajc seznam
	  erase_sada_uloh(p_ulohy_body_max);
	  // do przdnho seznam a pidej tuto lohu
	  add_sada_uloha(p_ulohy_body_max, p_uloha);
	  body_max = p_uloha->body_ulohy;
	}
        else if (p_uloha->body_ulohy == body_max) {
	  // pidej tuto lohu
	  add_sada_uloha(p_ulohy_body_max, p_uloha);
	}
        // loha za nejmn bod
        if (p_uloha->body_ulohy < body_min) {
	  // vyma stvajc seznam
	  erase_sada_uloh(p_ulohy_body_min);
	  // do przdnho seznam a pidej tuto lohu
	  add_sada_uloha(p_ulohy_body_min, p_uloha);
	  body_min = p_uloha->body_ulohy;
	}
        else if (p_uloha->body_ulohy == body_min) {
	  // pidej tuto lohu
	  add_sada_uloha(p_ulohy_body_min, p_uloha);
	}

	// projdi vechna een
	p_reseni_ulohy = p_uloha->p_first_reseni_ulohy;
	// zatm dn body
	suma_bodu_reseni = 0;
	while (p_reseni_ulohy != NULL) {
	  // piti body dalho een
	  suma_bodu_reseni += p_reseni_ulohy->p_reseni->body_reseni;
	  // move on
	  p_reseni_ulohy = p_reseni_ulohy->p_next_reseni_ulohy;
	}
	// zapamatuj si nejvt
	if (suma_bodu_reseni > suma_bodu_reseni_max) {
	  // vyma stvajc seznam
	  erase_sada_uloh(p_ulohy_body_sum_max);
	  // do przdnho seznam a pidej tuto lohu
	  add_sada_uloha(p_ulohy_body_sum_max, p_uloha);
	  suma_bodu_reseni_max = suma_bodu_reseni;
	}
        else if (suma_bodu_reseni == suma_bodu_reseni_max) {
	  // pidej tuto lohu
	  add_sada_uloha(p_ulohy_body_sum_max, p_uloha);
	}
	// zapamatuj si nejmen
	if (suma_bodu_reseni < suma_bodu_reseni_min) {
	  // vyma stvajc seznam
	  erase_sada_uloh(p_ulohy_body_sum_min);
	  // do przdnho seznam a pidej tuto lohu
	  add_sada_uloha(p_ulohy_body_sum_min, p_uloha);
	  suma_bodu_reseni_min = suma_bodu_reseni;
	}
        else if (suma_bodu_reseni == suma_bodu_reseni_min) {
	  // pidej tuto lohu
	  add_sada_uloha(p_ulohy_body_sum_min, p_uloha);
	}

  /*
Njak nej...

- s nejvtm rozdlem vechna - pln een

- tento msc

  */

        // move on
        p_uloha = p_uloha->p_next_uloha;
      }
      // pejdi na dal archiv
      p_archiv = p_archiv->p_next_archiv;
    }
  }

  // Jestlie je seznam eitel przdn...
  if ((p_seznam_resitelu == NULL) || (p_seznam_resitelu->p_first_resitel == NULL) || (p_seznam_resitelu->n_resitelu == 0)) {
    error_message(NO_RESITELE_IN_LIST, NULL);
  }
  else {
    // zani prvnm eitelem v seznamu
    p_resitel = p_seznam_resitelu->p_first_resitel;
    // projdi seznam vech eitel
    while (p_resitel != NULL) {
      // pipoti jeho body
      suma_bodu_resitelu += p_resitel->suma_bodu;
      // poet een
      n_reseni_resitelu += p_resitel->pocet_uloh;
      // eitel s nejvce body
      if (p_resitel->suma_bodu > resitele_body_max) {
        // vyma stvajc seznam
	erase_sada_resitelu(p_resitele_body_max);
	// do przdnho seznam a pidej tohoto eitele
	add_sada_resitel(p_resitele_body_max, p_resitel);
	resitele_body_max = p_resitel->suma_bodu;
      }
      else if (p_resitel->suma_bodu == resitele_body_max) {
	// pidej tohoto eitele
	add_sada_resitel(p_resitele_body_max, p_resitel);
      }
      // eitel s nejmn body
      if (p_resitel->suma_bodu < resitele_body_min) {
        // vyma stvajc seznam
	erase_sada_resitelu(p_resitele_body_min);
	// do przdnho seznam a pidej tohoto eitele
	add_sada_resitel(p_resitele_body_min, p_resitel);
	resitele_body_min = p_resitel->suma_bodu;
      }
      else if (p_resitel->suma_bodu == resitele_body_min) {
	// pidej tohoto eitele
	add_sada_resitel(p_resitele_body_min, p_resitel);
      }
      // nejstar eitel
      // nejnovj eitel

  /*
Njak nej...
- eitel: nejvce een
- eitel: nejmn een

- nejstar eitel
- nejnovj eitel

- tento msc
  */

      // dal eitel v seznamu
      p_resitel = p_resitel->p_next_resitel;
    }
  }

  // hlavika pehledu nej
  fprintf(soubor_statistika, "<h3>Rzn nej...</h3>\n\n");

  // pehled celkov
  fprintf(soubor_statistika, "<h4>Celkov</h3>\n\n");
  fprintf(soubor_statistika, "<ul>\n");
  // poet archiv
  fprintf(soubor_statistika, "  <li>Na strnkch je celkem %d archivnch soubor (vetn hlavn strnky).</li>\n", p_seznam_uloh->n_archivu);
  // srovnn potu loh a eitel
  if (p_seznam_uloh->n_uloh > p_seznam_resitelu->n_resitelu) {
    fprintf(soubor_statistika, "  <li>Na strnkch je vce loh (celkem %d) ne eitel (celkem %d).</li>\n", p_seznam_uloh->n_uloh, p_seznam_resitelu->n_resitelu);
  }
  else if (p_seznam_uloh->n_uloh > p_seznam_resitelu->n_resitelu) {
    fprintf(soubor_statistika, "  <li>een se zastilo eitel (celkem %d) ne je loh (celkem %d).</li>\n", p_seznam_resitelu->n_resitelu, p_seznam_uloh->n_uloh);
  }
  else {
    fprintf(soubor_statistika, "  <li>een se zastilo stejn eitel (celkem %d) jako je loh (celkem %d).</li>\n", p_seznam_resitelu->n_resitelu, p_seznam_uloh->n_uloh);
  }
  // souet bod loh celkem
  fprintf(soubor_statistika, "  <li>Za sprvn een vech loh je mono zskat %d bod.</li>\n", suma_bodu);
  // poet vech een a souet bod eitel celkem
  fprintf(soubor_statistika, "  <li>eitel poslali %ld een a nasbrali celkem %ld bod.</li>\n", n_reseni_resitelu, suma_bodu_resitelu);
  // konec pehledu celkovho
  fprintf(soubor_statistika, "</ul>\n");

  // pehled pro lohy --------------------------------------------------------------------
  fprintf(soubor_statistika, "<h4>O lohch</h3>\n\n");
  fprintf(soubor_statistika, "<ul>\n");
  // poet loh
  fprintf(soubor_statistika, "  <li>V archivech je celkem %d loh.</li>\n", p_seznam_uloh->n_uloh);
  // loha s nejvce eenmi
  fprintf(soubor_statistika, "  <li>Nejastji een%s loh%s: ", (p_ulohy_reseni_max->n_uloh == 1) ? "" : "", (p_ulohy_reseni_max->n_uloh == 1) ? "a" : "y");
  print_sada_uloh(soubor_statistika, p_ulohy_reseni_max);
  fprintf(soubor_statistika, " (%lu een).</li>\n", reseni_max);
  // loha s nejmn eenmi
  fprintf(soubor_statistika, "  <li>Nejmn asto een%s loh%s: ", (p_ulohy_reseni_min->n_uloh == 1) ? "" : "", (p_ulohy_reseni_min->n_uloh == 1) ? "a" : "y");
  print_sada_uloh(soubor_statistika, p_ulohy_reseni_min);
  fprintf(soubor_statistika, " (%lu een).</li>\n", reseni_min);
  // loha s nejvce plnmi eenmi
  fprintf(soubor_statistika, "  <li>Nejastji sprvn een%s loh%s: ", (p_ulohy_uplne_reseni_max->n_uloh == 1) ? "" : "", (p_ulohy_uplne_reseni_max->n_uloh == 1) ? "a" : "y");
  print_sada_uloh(soubor_statistika, p_ulohy_uplne_reseni_max);
  fprintf(soubor_statistika, " (%lu een).</li>\n", uplne_reseni_max);
  // loha s nejmn plnmi eenmi
  fprintf(soubor_statistika, "  <li>Nejmn asto sprvn een%s loh%s: ", (p_ulohy_uplne_reseni_min->n_uloh == 1) ? "" : "", (p_ulohy_uplne_reseni_min->n_uloh == 1) ? "a" : "y");
  print_sada_uloh(soubor_statistika, p_ulohy_uplne_reseni_min);
  fprintf(soubor_statistika, " (%lu een).</li>\n", uplne_reseni_min);
  // loha s nejvtm rozdlem sprvnch a stench een
  fprintf(soubor_statistika, "  <li>loh%s s&nbsp;nejvtm rozdlem plnch a stench een: ", (p_ulohy_max_rozdil_reseni->n_uloh == 1) ? "a" : "y");
  print_sada_uloh(soubor_statistika, p_ulohy_max_rozdil_reseni);
  fprintf(soubor_statistika, " (rozdl %lu een).</li>\n", max_rozdil_reseni);
  // loha za nejvce bod
  fprintf(soubor_statistika, "  <li>loh%s za nejvce bod: ", (p_ulohy_body_max->n_uloh == 1) ? "a" : "y");
  print_sada_uloh(soubor_statistika, p_ulohy_body_max);
  fprintf(soubor_statistika, " (%d bod).</li>\n", body_max);
  // loha za nejmn bod
  fprintf(soubor_statistika, "  <li>loh%s za nejmn bod: ", (p_ulohy_body_min->n_uloh == 1) ? "a" : "y");
  print_sada_uloh(soubor_statistika, p_ulohy_body_min);
  fprintf(soubor_statistika, " (%d bod).</li>\n", body_min);
  // loha za kterou nasbrno nejvce bod
  fprintf(soubor_statistika, "  <li>loh%s za kter%s bylo nasbrno nejvce bod: ", (p_ulohy_body_sum_max->n_uloh == 1) ? "a" : "y", (p_ulohy_body_sum_max->n_uloh == 1) ? "ou" : "");
  print_sada_uloh(soubor_statistika, p_ulohy_body_sum_max);
  fprintf(soubor_statistika, " (%ld bod).</li>\n", suma_bodu_reseni_max);
  // loha za kterou nasbrno nejvce bod
  fprintf(soubor_statistika, "  <li>loh%s za kter%s bylo nasbrno nejmn bod: ", (p_ulohy_body_sum_min->n_uloh == 1) ? "a" : "y", (p_ulohy_body_sum_min->n_uloh == 1) ? "ou" : "");
  print_sada_uloh(soubor_statistika, p_ulohy_body_sum_min);
  fprintf(soubor_statistika, " (%ld bod).</li>\n", suma_bodu_reseni_min);
  // konec pehledu loh
  fprintf(soubor_statistika, "</ul>\n");

  // pehled pro eitele --------------------------------------------------------------------
  fprintf(soubor_statistika, "<h4>O eitelch</h3>\n\n");
  fprintf(soubor_statistika, "<ul>\n");
  // poet eitel
  //T  fprintf(soubor_statistika, "  <li>Dostal jsem een od %d eitel, tento msc od %d eitel.</li>\n", p_seznam_resitelu->n_resitelu, seznam_resitelu_mesice->n_resitelu);
  fprintf(soubor_statistika, "  <li>Dostal jsem een od %d eitel.</li>\n", p_seznam_resitelu->n_resitelu);
  // nejvt souet bod celkem
  fprintf(soubor_statistika, "  <li>eitel%s s nejvtm potem bod: ", (p_resitele_body_max->n_resitelu == 1) ? "" : "");
  print_sada_resitelu(soubor_statistika, p_resitele_body_max);
  fprintf(soubor_statistika, " (%d bod).", resitele_body_max);
  if (resitele_body_max == suma_bodu) {
    fprintf(soubor_statistika, " <span class=\"pozor\">Vyeil%s sprvn vechny lohy!</span>", (p_resitele_body_max->n_resitelu == 1) ? "" : "i");
  }
  fprintf(soubor_statistika, "</li>\n");
  // nejmen souet bod celkem
  fprintf(soubor_statistika, "  <li>eitel%s s nejmenm potem bod: ", (p_resitele_body_min->n_resitelu == 1) ? "" : "");
  print_sada_resitelu(soubor_statistika, p_resitele_body_min);
  fprintf(soubor_statistika, " (%d bod%s).</li>\n", resitele_body_min, (resitele_body_min == 1) ? "" : "");
  // konec pehledu eitel
  fprintf(soubor_statistika, "</ul>\n");

  /*
  // pehled pro een --------------------------------------------------------------------
  fprintf(soubor_statistika, "<h4>O eench</h3>\n\n");
  fprintf(soubor_statistika, "<ul>\n");
  // konec pehledu een
  fprintf(soubor_statistika, "</ul>\n");

Njak nej...
- nejstar een
- nejnovj een
  */

  // uvoln struktury
  free_sada_uloh(p_ulohy_body_max);
  free_sada_uloh(p_ulohy_body_min);
  free_sada_uloh(p_ulohy_reseni_max);
  free_sada_uloh(p_ulohy_reseni_min);
  free_sada_uloh(p_ulohy_uplne_reseni_max);
  free_sada_uloh(p_ulohy_uplne_reseni_min);
  free_sada_uloh(p_ulohy_max_rozdil_reseni);
  free_sada_uloh(p_ulohy_body_sum_max);
  free_sada_uloh(p_ulohy_body_sum_min);
  free_sada_resitelu(p_resitele_body_max);
  free_sada_resitelu(p_resitele_body_min);

  // done
  return OK;
}

// Vytvo soubor statistika.php se seznamem loh, eitel i een rozdlench podle rok i celkov
STATUS create_statistika_file(PARAMETERS * parameters, SEZNAM_RESENI * p_seznam_reseni, SEZNAM_ULOH * p_seznam_uloh, SEZNAM_RESITELU * p_seznam_resitelu) {
  FILE * soubor_statistika;                    // vstupn soubor statistika.php

  // Zprva co se dje
  if (parameters->verbosity_level > 2) {
    fprintf(stdout, "Generuji '%s' ...", parameters->out_file_statistika);
  }

  // Otevi soubor statistika.php
  if ((soubor_statistika = fopen(parameters->out_file_statistika, "wt")) == NULL) {
    error_message(CANT_OPEN_STATISTIKA_FILE, parameters->out_file_statistika);
    //D    exit(CANT_OPEN_STATISTIKA_FILE);
  }

  // hlavika
  include_file(soubor_statistika, parameters->statistika_head, CANT_OPEN_STATISTIKA_HEADINGS, NOT_CLOSED_STATISTIKA_HEADINGS);

  // ------------------------------

  // poty een
  pocty_reseni_uloh(p_seznam_uloh, soubor_statistika);

  // nkolik nej
  nekolik_nej(p_seznam_resitelu, p_seznam_uloh, soubor_statistika);

  // ------------------------------

  // patika 
  include_file(soubor_statistika, parameters->statistika_tail, CANT_OPEN_STATISTIKA_TAILS, NOT_CLOSED_STATISTIKA_TAILS);

  // zave soubor se statistikami
  if (fclose(soubor_statistika) != 0) {
    error_message(NOT_CLOSED_STATISTIKA_FILE, parameters->out_file_statistika);
  }
  // zprva o skonen
  if (parameters->verbosity_level > 2) {
    fprintf(stdout, " dokoneno.\n");
  }
  // done
  return OK;
}

// ------------------------------------------------------------------------------------------------------------------------

// end of file
